hdu 1007 Quoit Design 分治求最近点对

Quoit Design


Time Limit: 10000/5000 MS
(Java/Others)    Memory Limit: 65536/32768 K
(Java/Others)
Total Submission(s): 29344    Accepted
Submission(s): 7688

Problem Description

Have you ever played quoit in a playground? Quoit is
a game in which flat rings are pitched at some toys, with all the toys encircled
awarded.
In the field of Cyberground, the position of each toy is fixed, and
the ring is carefully designed so it can only encircle one toy at a time. On the
other hand, to make the game look more attractive, the ring is designed to have
the largest radius. Given a configuration of the field, you are supposed to find
the radius of such a ring.

Assume that all the toys are points on a
plane. A point is encircled by the ring if the distance between the point and
the center of the ring is strictly less than the radius of the ring. If two toys
are placed at the same point, the radius of the ring is considered to be
0.

Input

The input consists of several test cases. For each
case, the first line contains an integer N (2 <= N <= 100,000), the total
number of toys in the field. Then N lines follow, each contains a pair of (x, y)
which are the coordinates of a toy. The input is terminated by N = 0.

Output

For each test case, print in one line the radius of
the ring required by the Cyberground manager, accurate up to 2 decimal
places.

Sample Input

2

0 0

1 1

2

1 1

1 1

3

-1.5

0 0

0 0

1.5

0

Sample Output

0.71

0.00

0.75

题目大意:给n个点,求最近点对距离的一半。

按x值排序,分治法二分递归搜索,合并的时候注意一下把那些fabs(p[i].x-p[mid].x)<=ans的点找出来,这些点中可能有更小的ans,把他们按y值排序,暴力两层循环更新ans,当p[j].y-p[i].y>=ans时没必要继续了。


 1 #include <iostream>
2 #include <cstdio>
3 #include <cmath>
4 #include <algorithm>
5 using namespace std;
6
7 const int maxn=100005;
8 int N,f[maxn];
9 struct Point
10 {
11 double x,y;
12 }p[maxn];
13
14 double min(double a,double b){ return a<b?a:b;}
15 bool cmpx(const Point &a,const Point &b)
16 {
17 return a.x<b.x;
18 }
19 bool cmpy(const int a,const int b)
20 {
21 return p[a].y<p[b].y;
22 }
23 double dist(int a,int b)
24 {
25 return sqrt((p[a].x-p[b].x)*(p[a].x-p[b].x)+(p[a].y-p[b].y)*(p[a].y-p[b].y));
26 }
27 double BinarySearch(int l,int r)
28 {
29 if(l+1==r)
30 {
31 return dist(l,r);
32 }
33 if(l+2==r)
34 {
35 return min(min(dist(l,l+1),dist(l+1,l+2)),dist(l,l+2));
36 }
37 int mid=(l+r)>>1;
38 double ans=min(BinarySearch(l,mid),BinarySearch(mid+1,r));
39 int i,j,cnt=0;
40 for(i=l;i<=r;i++)
41 {
42 if(fabs(p[i].x-p[mid].x)<=ans)
43 f[cnt++]=i;
44 }
45 sort(f,f+cnt,cmpy);
46 for(i=0;i<cnt;i++)
47 {
48 for(j=i+1;j<cnt;j++)
49 {
50 if(p[f[j]].y-p[f[i]].y>=ans) break;
51 ans=min(ans,dist(f[i],f[j]));
52 }
53 }
54 return ans;
55 }
56 int main()
57 {
58 while(scanf("%d",&N),N)
59 {
60 for(int i=0;i<N;i++)
61 scanf("%lf %lf",&p[i].x,&p[i].y);
62 sort(p,p+N,cmpx);
63 printf("%.2lf\n",BinarySearch(0,N-1)/2);
64 }
65 return 0;
66 }

hdu 1007 Quoit Design 分治求最近点对

时间: 2024-10-12 17:58:54

hdu 1007 Quoit Design 分治求最近点对的相关文章

HDU 1007 [Quoit Design] 分治

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1007 题目大意:N个点,求最近一对点的距离的一半. 关键思想:最傻瓜式的枚举所有点对的距离找最短 O(n^2),会TLE. 分治可以优化成O(nlogn).二分区间,考虑三种情形:点对的两点都在左区间.两点都在右区间.两点一左一右 前两种情况,可以递归地解出来,分别为d1,d2.第三种,可以依据min(d1,d2)收缩成一条带状区域(勾股定理显然). 然后对带中所有点进行处理,此时又可依据min(d

HDU 1007 Quoit Design (分治)

Quoit Design Problem Description Have you ever played quoit in a playground? Quoit is a game in which flat rings are pitched at some toys, with all the toys encircled awarded. In the field of Cyberground, the position of each toy is fixed, and the ri

HDU 1007 Quoit Design【计算几何/分治/最近点对】

Quoit Design Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 58566    Accepted Submission(s): 15511 Problem Description Have you ever played quoit in a playground? Quoit is a game in which flat

分治算法应用-最近点对的最小距离-hdu 1007 Quoit Design

题目描述 给出二维平面上的n个点,求其中最近的两个点的距离的一半. 输入包含多组数据,每组数据第一行为n,表示点的个数:接下来n行,每行一个点的坐标.当n为0时表示输入结束,每组数据输出一行,为最近的两个点的距离的一半. 输入样例: 2 0 0 1 1 2 1 1 1 1 3 -1.5 0 0 0 0 1.5 0 输出样例: 0.71 0.00 0.75 题目解析: 采用分治的思想,把n个点按照x坐标进行排序,以坐标mid为界限分成左右两个部分,对左右两个部分分别求最近点对的距离,然后进行合并.

分治 [HDU 1007] Quoit Design

Quoit Design Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 33577    Accepted Submission(s): 8800 Problem Description Have you ever played quoit in a playground? Quoit is a game in which flat

HDU 1007 Quoit Design

Quoit Design Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 130 Accepted Submission(s): 72   Problem Description Have you ever played quoit in a playground? Quoit is a game in which flat rings a

HDU 1007 Quoit Design(二分+浮点数精度控制)

Quoit Design Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 47104    Accepted Submission(s): 12318 Problem Description Have you ever played quoit in a playground? Quoit is a game in which fla

hdu 1007 Quoit Design (经典分治 求最近点对)

Problem Description Have you ever played quoit in a playground? Quoit is a game in which flat rings are pitched at some toys, with all the toys encircled awarded.In the field of Cyberground, the position of each toy is fixed, and the ring is carefull

hdu 1007 Quoit Design, 平面最近点对

平面最近点对的经典做法就是分治.所有点先按x再按y排序,然后取中间位置的点,利用其x坐标值将点划分成左右两部分,分别求出两侧的最近点对(设其距离为δ),然后合并.参看下面的图片(来自guyulongcs的专栏,http://blog.csdn.net/guyulongcs/article/details/6841550)合并的时候需要注意,大致有两种做法,一种是把分界线两侧δ范围内的点分别加进一个数组,然后对右侧数组按y坐标值排序,之后依次为每个左侧数组中的点,在右侧数组中寻找与其y坐标值最近的